System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _decorator, Component, find, Node, Sprite, Texture2D, _cc, _dec, _dec2, _class, _class2, _descriptor, _crd, cc, ccclass, property, SpineBoyCtrl;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'transform-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _decorator = _cc2._decorator;
      Component = _cc2.Component;
      find = _cc2.find;
      Node = _cc2.Node;
      Sprite = _cc2.Sprite;
      Texture2D = _cc2.Texture2D;
      _cc = _cc2;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "53dadWeGdhHaKU+sHzYFFMR", "SpineBoyCtrl", undefined);

      __checkObsolete__(['_decorator', 'CCClass', 'Component', 'find', 'sp', 'Node', 'Sprite', 'Texture2D']);

      cc = __checkObsoleteInNamespace__(_cc);
      ({
        ccclass,
        property
      } = _decorator);

      _export("default", SpineBoyCtrl = (_dec = ccclass('SpineBoyCtrl'), _dec2 = property({
        type: Texture2D
      }), _dec(_class = (_class2 = class SpineBoyCtrl extends Component {
        constructor(...args) {
          super(...args);
          this.mixTime = 0.2;

          _initializerDefineProperty(this, "imgTexture2D", _descriptor, this);

          this.spine = void 0;
          this._hasStop = true;
        }

        onLoad() {
          var spine = this.spine = this.getComponent('sp.Skeleton');

          this._setMix('walk', 'run');

          this._setMix('run', 'jump');

          this._setMix('walk', 'jump');

          spine.setStartListener(trackEntry => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            console.log("[track %s][animation %s] start.", trackEntry.trackIndex, animationName);
          });
          spine.setInterruptListener(trackEntry => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            console.log("[track %s][animation %s] interrupt.", trackEntry.trackIndex, animationName);
          });
          spine.setEndListener(trackEntry => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            console.log("[track %s][animation %s] end.", trackEntry.trackIndex, animationName);
          });
          spine.setDisposeListener(trackEntry => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            console.log("[track %s][animation %s] will be disposed.", trackEntry.trackIndex, animationName);
          });
          spine.setCompleteListener(trackEntry => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";

            if (animationName === 'shoot') {
              this.spine.clearTrack(1);
            }

            var loopCount = Math.floor(trackEntry.trackTime / trackEntry.animationEnd);
            console.log("[track %s][animation %s] complete: %s", trackEntry.trackIndex, animationName, loopCount);
          });
          spine.setEventListener((trackEntry, event) => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            console.log("[track %s][animation %s] event: %s, %s, %s, %s", trackEntry.trackIndex, animationName, event.data.name, event.intValue, event.floatValue, event.stringValue);
          });
          find('Canvas/Animation Buttons/Stop').on(Node.EventType.TOUCH_END, this.stop, this);
          find('Canvas/Animation Buttons/Walk').on(Node.EventType.TOUCH_END, this.walk, this);
          find('Canvas/Animation Buttons/Run').on(Node.EventType.TOUCH_END, this.run, this);
          find('Canvas/Animation Buttons/Jump').on(Node.EventType.TOUCH_END, this.jump, this);
          find('Canvas/Animation Buttons/Shoot').on(Node.EventType.TOUCH_END, this.shoot, this);
          find('Canvas/Animation Buttons/Idle').on(Node.EventType.TOUCH_END, this.idle, this);
          find('Canvas/Animation Buttons/Portal').on(Node.EventType.TOUCH_END, this.portal, this);
          find('Canvas/skinBtn').on(Node.EventType.TOUCH_END, () => {
            let sp = find('Canvas/Sprite').getComponent(Sprite).spriteFrame.texture;
            let newTexture = new Texture2D();
            newTexture = this.imgTexture2D;
            this.spine.setSlotTexture("head", newTexture, true);
          }, this);
          this._hasStop = false;
        }
        /** 从纹理里面读取指定区域的图像缓存数据 */


        readTexturePixels(texture, rect) {
          const gfxTexture = texture.getGFXTexture();
          if (gfxTexture == null) return null;
          const bufferSize = 4 * texture.width * texture.height;
          const buffer = new Uint8Array(bufferSize);
          const region = new cc.gfx.BufferTextureCopy();
          region.texOffset.x = rect.x;
          region.texOffset.y = rect.y;
          region.texExtent.width = rect.width;
          region.texExtent.height = rect.height;
          const gfxDevice = texture['_getGFXDevice']();
          gfxDevice.copyTextureToBuffers(gfxTexture, [buffer], [region]);
          return buffer;
        } // OPTIONS


        toggleDebugSlots() {
          var _this$spine;

          this.spine.debugSlots = !((_this$spine = this.spine) != null && _this$spine.debugSlots);
        }

        toggleDebugBones() {
          var _this$spine2;

          this.spine.debugBones = !((_this$spine2 = this.spine) != null && _this$spine2.debugBones);
        }

        toggleDebugMesh() {
          var _this$spine3;

          this.spine.debugMesh = !((_this$spine3 = this.spine) != null && _this$spine3.debugMesh);
        }

        toggleUseTint() {
          var _this$spine4;

          this.spine.useTint = !((_this$spine4 = this.spine) != null && _this$spine4.useTint);
        }

        toggleTimeScale() {
          if (this.spine.timeScale === 1.0) {
            this.spine.timeScale = 0.3;
          } else {
            this.spine.timeScale = 1.0;
          }
        } // ANIMATIONS


        stop() {
          var _this$spine5;

          (_this$spine5 = this.spine) == null || _this$spine5.clearTrack(0);
          this._hasStop = true;
        }

        walk() {
          var _this$spine7;

          if (this._hasStop) {
            var _this$spine6;

            (_this$spine6 = this.spine) == null || _this$spine6.setToSetupPose();
          }

          (_this$spine7 = this.spine) == null || _this$spine7.setAnimation(0, 'walk', true);
          this._hasStop = false;
        }

        run() {
          var _this$spine9;

          if (this._hasStop) {
            var _this$spine8;

            (_this$spine8 = this.spine) == null || _this$spine8.setToSetupPose();
          }

          (_this$spine9 = this.spine) == null || _this$spine9.setAnimation(0, 'run', true);
          this._hasStop = false;
        }

        jump() {
          var _this$spine11;

          if (this._hasStop) {
            var _this$spine10;

            (_this$spine10 = this.spine) == null || _this$spine10.setToSetupPose();
          }

          (_this$spine11 = this.spine) == null || _this$spine11.setAnimation(0, 'jump', true);
          this._hasStop = false;
        }

        shoot() {
          var _this$spine12;

          (_this$spine12 = this.spine) == null || _this$spine12.setAnimation(1, 'shoot', false);
        }

        idle() {
          var _this$spine13, _this$spine14;

          (_this$spine13 = this.spine) == null || _this$spine13.setToSetupPose();
          (_this$spine14 = this.spine) == null || _this$spine14.setAnimation(0, 'idle', true);
        }

        portal() {
          var _this$spine15, _this$spine16;

          (_this$spine15 = this.spine) == null || _this$spine15.setToSetupPose();
          (_this$spine16 = this.spine) == null || _this$spine16.setAnimation(0, 'portal', false);
        } //


        _setMix(anim1, anim2) {
          var _this$spine17, _this$spine18;

          (_this$spine17 = this.spine) == null || _this$spine17.setMix(anim1, anim2, this.mixTime);
          (_this$spine18 = this.spine) == null || _this$spine18.setMix(anim2, anim1, this.mixTime);
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "imgTexture2D", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: null
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=9d79887d3c120cfeed6c857d4947950f34cf1fde.js.map