System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _decorator, Component, _cc, _dec, _class, _crd, cc, ccclass, property, Spine;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  return {
    setters: [function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _decorator = _cc2._decorator;
      Component = _cc2.Component;
      _cc = _cc2;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9d229ElKyZMprjy65qt9Ehe", "Spine", undefined);

      __checkObsolete__(['_decorator', 'Component', 'Node']);

      cc = __checkObsoleteInNamespace__(_cc);
      ({
        ccclass,
        property
      } = _decorator);

      _export("Spine", Spine = (_dec = ccclass('Spine'), _dec(_class = class Spine extends Component {
        start() {
          this.addSpine();
        }

        addSpine() {
          var _this = this;

          return _asyncToGenerator(function* () {
            // 创建一个新节点
            var newNode = new cc.Node('dynamicSpine'); // 将节点添加到当前节点下

            _this.node.addChild(newNode); // 添加spine组件


            var spineComp = newNode.addComponent(cc.sp.Skeleton); // 设置spine资源

            var skeletonData = new cc.sp.SkeletonData();

            try {
              // 使用Promise方式加载远程资源
              var skeletonJsonAsset = yield _this.loadRemoteText('http://172.17.196.11:800/fairy/role/a0/girl_front.json');
              var atlasTextAsset = yield _this.loadRemoteText('http://172.17.196.11:800/fairy/role/a0/girl_00.atlas');
              var textureAsset = yield _this.loadRemoteAsset('http://172.17.196.11:800/fairy/role/a0/girl_00.png');
              var dd = new cc.Texture2D();
              dd.image = textureAsset;
              skeletonData.skeletonJson = skeletonJsonAsset;
              skeletonData.atlasText = atlasTextAsset.toString();
              skeletonData.textures = [dd];
              skeletonData.textureNames = ['girl_00.png']; //必须设置正确的图片文件名，否则app里面会崩溃

              skeletonData._uuid = "aaaa"; // 可以传入任意字符串，但不能为空

              spineComp.skeletonData = skeletonData;
              spineComp.setSkin("skin/skin_yellow"); // 设置动画

              spineComp.setAnimation(0, "stand", true); // 设置位置

              newNode.setPosition(100, 0);
            } catch (error) {
              cc.error("加载Spine资源失败:", error);
            }
          })();
        } // 辅助方法：加载远程资源并返回Promise


        loadRemoteAsset(url) {
          return new Promise((resolve, reject) => {
            cc.assetManager.loadRemote(url, (err, asset) => {
              if (err) {
                reject(err);
              } else {
                resolve(asset);
              }
            });
          });
        }

        loadRemoteText(url) {
          return new Promise((resolve, reject) => {
            cc.assetManager.loadRemote(url, {
              ext: '.txt'
            }, (err, asset) => {
              if (err) {
                reject(err);
              } else {
                resolve(asset.text);
              }
            });
          });
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=4eb8e9ac0c25c8139ceb702d35257d1b37dee35f.js.map